Transcript show: 'Patching Object....'; cr.

!

!Object methodsFor: 'error handling' stamp: 'shrink 8/27/2004 20:00'!
confirm: queryString
	"Put up a yes/no menu with caption queryString. Answer true if the 
	response is yes, false if no. This is a modal question--the user must 
	respond yes or no."

	"nil confirm: 'Are you hungry?'"

	^ CurrentConsole confirm: queryString! !

!Object methodsFor: 'error handling' stamp: 'shrink 8/27/2004 20:00'!
confirm: aString orCancel: cancelBlock
	"Put up a yes/no/cancel menu with caption aString. Answer true if  
	the response is yes, false if no. If cancel is chosen, evaluate  
	cancelBlock. This is a modal question--the user must respond yes or no."

	^ CurrentConsole confirm: aString orCancel: cancelBlock! !
	
!Object methodsFor: 'user interface' stamp: 'shrink 8/27/2004 20:00'!
inform: aString
	
	aString isEmptyOrNil ifFalse: [CurrentConsole inform: aString]! !
	
!Object methodsFor: 'primitive' stamp: 'shrink 8/27/2004 20:00'!
primitiveError: aString

	Transcript 
		cr; cr; 
		show: '***System error handling failed***'; cr;
		show: aString; cr;
		show: thisContext asString; cr;
		show: thisContext stack.! !
		
!Object methodsFor: 'instance creation' stamp: 'shrink 8/27/2004 20:00'!
readCarefullyFrom: textOrString
	"Create an object based on the contents of textOrString.  Return an error instead of putting up a SyntaxError window."

	| object ok |
	ok _ (textOrString isKindOf: Stream) or: [textOrString isKindOf: String].
	(ok) ifFalse: [^ self error: 'expected String or Text'].
	object _ Compiler evaluate: textOrString for: nil 
				notifying: #error: "signal we want errors" logged: false.
	(object isKindOf: self) ifFalse: [self error: self name, ' expected'].
	^object! !
	
!Object methodsFor: 'instance creation' stamp: 'shrink 8/27/2004 20:00'!
readFrom: aStream
	"Create an object based on the contents of aStream."

	| object ok |
	ok _ (aStream isKindOf: Stream) or: [aStream isKindOf: String].
	(ok) ifFalse: [^ self error: 'expected String or Text'].
	object _ Compiler evaluate: aStream.
	(object isKindOf: self) ifFalse: [self error: self name, ' expected'].
	^object! !
	
